
# from datetime import datetime, timezone
# from playwright.async_api import async_playwright, Playwright
# from playwright.sync_api import expect
from playwright.async_api import Playwright, async_playwright, expect
import random

from base_class import BaseVariableFunction
from base_class import *
baseclass = BaseVariableFunction(__file__)

baseclass.makedirpath(baseclass.browsercookie_path)
baseclass.makedirpath(baseclass.dalao_solscan_info_path)
old_print = print


def timestamped_print(*args, **kwargs):
    old_print(datetime.datetime.utcnow().replace(
        microsecond=0), *args, **kwargs)


print = timestamped_print
print('\n'*5)
print(f"{'{:<6}'.format('ENTER')} {baseclass.scriptfilename} ----------------NOTE-----------NOTE---------------")
 
arr_exclude_address=[
    
]

now_time = time.time()
 
df = pd.read_excel(baseclass.dalao_tran_gmgnOrdex_path /
                 "input_dalao.xlsx", dtype=object)
arr_str_dalaoaddress = df['dalaoaddress'].tolist()

for str_dalaoaddress in arr_str_dalaoaddress:
    df_sol_transfer =pd.read_csv(baseclass.dalao_solscan_info_path / f"sol_transfer_{str_dalaoaddress}.csv")
    df_token_inflow =pd.read_csv(baseclass.dalao_solscan_info_path / f"token_inflow{str_dalaoaddress}.csv")
    df_token_outflow =pd.read_csv(baseclass.dalao_solscan_info_path / f"token_outflow{str_dalaoaddress}.csv")
    df_usdc_transfer =pd.read_csv(baseclass.dalao_solscan_info_path / f"usdc_transfer{str_dalaoaddress}.csv")
    df_sol_transfer=df_sol_transfer.astype({
        
        "Time":int,
    })
    arr_no_sol_transfer_tx_01 = df_token_inflow["Signature"].tolist() + df_token_outflow["Signature"].tolist() + df_usdc_transfer["Signature"].tolist()
    df_sol_transfer = df_sol_transfer[~df_sol_transfer["Signature"].isin(arr_no_sol_transfer_tx_01)].reset_index(drop=True)
    mask_arr_no_sol_transfer_tx_02 =(  df_sol_transfer["Action"]!="TRANSFER"   
                                     | df_sol_transfer["Time"]<now_time -  1.5*30* 3600*24 
                                     | df_sol_transfer["From"].isin(arr_exclude_address)
                                      | df_sol_transfer["To"].isin(arr_exclude_address)
                                     )
    df_sol_transfer = df_sol_transfer[mask_arr_no_sol_transfer_tx_02].reset_index(drop=True)
    df_sol_transfer.columns=["txhash","timestamp","action","from","to","amount","decimals","tokenaddress"]
    df_sol_transfer=df_sol_transfer[["txhash","timestamp", "from","to","amount", "tokenaddress"]]
    print(df_sol_transfer)
 